unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, IntfGraphics,
  StdCtrls;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FFraction: Double;
    FImage1: TLazIntfImage;
    FImage2: TLazIntfImage;
    FImage: TLazIntfImage;
    FBitmap: TBitmap;
    FDirection: Boolean;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  fpimage;

const 
  IMG_FILENAME_1 = 'cheetah.jpg';
  IMG_FILENAME_2 = 'cheetah-gespiegelt.jpg';

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  jpg: TJpegImage;
begin
  jpg := TJpegImage.Create;
  try
    jpg.LoadFromFile(IMG_FILENAME_1);
    FImage1 := jpg.CreateIntfImage;
  finally
    jpg.Free;
  end;
  
  jpg := TJpegImage.Create;
  try
    jpg.LoadFromFile(IMG_FILENAME_2);
    FImage2 := jpg.CreateIntfImage;
  finally
    jpg.Free;
  end;
  
  if (FImage1.Height <> FImage2.Height) or (FImage1.Width <> FImage2.Width) then
  begin
    MessageDlg('Bildgrößen sind unterschiedlich', mtError, [mbOK], 0);
    Close;
  end;
  
  FBitmap := TBitmap.Create;
  FBitmap.SetSize(FImage1.Width, FImage1.Height);
  
  Paintbox1.Width := FBitmap.Width;
  Paintbox1.Height := FBitmap.Height;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FDirection := not FDirection;
  if FDirection then
    FFraction := 0
  else
    FFraction := 1.0;
  Paintbox1.Invalidate;
  Timer1.Enabled := true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FBitmap.Free;
  FImage1.Free;
  FImage2.Free;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  x, y: Integer;
  r,g, b: Word;
  img: TLazIntfImage;
begin
  img := FBitmap.CreateIntfImage;
  try
    for y := 0 to FBitmap.Height-1 do
      for x := 0 to FBitmap.Width - 1 do
      begin
        r := round((1.0-FFraction) * FImage1.Colors[x, y].Red + FFraction * FImage2.Colors[x, y].Red);
        g := round((1.0-FFraction) * FImage1.Colors[x, y].Green + FFraction * FImage2.Colors[x, y].Green);
        b := round((1.0-FFraction) * FImage1.Colors[x, y].Blue + FFraction * FImage2.Colors[x, y].Blue);
        img.Colors[x, y] := FPColor(r, g, b);
      end;
  
    FBitmap.LoadFromIntfImage(img);
    Paintbox1.Canvas.Draw(0, 0, FBitmap);
  finally
    img.Free;
  end;
end; 

procedure TForm1.Timer1Timer(Sender: TObject);
const
  DELTA = 0.05;
begin
  if FDirection then
  begin
    FFraction := FFraction + DELTA;
    if FFraction >= 1.0 then
      Timer1.Enabled := false;
  end else
  begin
    FFraction := FFraction - DELTA;
    if FFraction <= 0.0 then
      Timer1.Enabled := false;
  end;
  Paintbox1.Invalidate;
end; 

end.

